﻿@model SiteInfo
@using SiteGuide.Service.Identifiers
@using SiteGuide.Service.Helpers
@using SiteGuide.Web.Helpers

@{
    ViewData["Title"] = $"{Model.Site.Name} - Site Details";
}

<hr />
@if (Model.RequestedVersionTreeNode != null)
{
    <div class="alert alert-warning" role="alert">
        @{
            switch (Model.RequestedVersionTreeNode)
            {
                case EditVersionIdentifier editVersion:
                    <text>
                        <p>
                            This is edit version @(editVersion.IdAndVersionNumber). ... more info here TODO ...
                        </p>
                    </text>
                    break;
                case VersionIdentifier:
                    <text>
                        <p>
                            This is a specific revision of this page. It may differ from the <a asp-route-id="@(Model.Site.Name)">current version</a>.
                        </p>
                        <p>
                            This is version @Model.VersionInfo.This.Id published @LocalTimeHelper.LocalTime(Model.VersionInfo.This.PublishedTime) (<a asp-controller="Versions" asp-action="Details" asp-route-id="@Model.VersionInfo.This.Id" asp-route-site="@(Model.Site.Name)">all changes</a>).
                            @if (Model.VersionInfo.Preceding != null)
                            {
                                <text>This replaced <a asp-route-id="@(Model.Site.Name)" asp-route-version="@(Model.VersionInfo.Preceding.Id)">version @Model.VersionInfo.Preceding.Id</a> published @LocalTimeHelper.LocalTime(Model.VersionInfo.Preceding.PublishedTime).</text>
                            }
                            else
                            {
                                <text>This is the first version of this page.</text>
                            }

                            @if (@Model.VersionInfo.Next == null)
                            {
                                <text>This is still the current version.</text>
                            }
                            else
                            {
                                <text>
                                    Replaced by <a asp-route-id="@(Model.Site.Name)" asp-route-version="@(Model.VersionInfo.Next.Id)">version @Model.VersionInfo.Next.Id</a> published @LocalTimeHelper.LocalTime(Model.VersionInfo.Next.PublishedTime).
                                    <a asp-route-id="@(Model.Site.Name)" asp-route-version="@(Model.VersionInfo.Latest.Id)">Version @Model.VersionInfo.Latest.Id</a> published @LocalTimeHelper.LocalTime(Model.VersionInfo.Latest.PublishedTime) is the latest version.
                                </text>
                            }
                        </p>
                        <p>Edit comment: "@Model.VersionInfo.This.Comment"</p>
                        <a class="btn btn-primary" role="button" asp-controller="Versions" asp-action="Index" asp-route-filterForSite="@(Model.Site.Name)">Show all versions which changed this site</a>
                    </text>
                    break;
            }
        }
    </div>
    <hr />
}

@if (Model.RequestedVersionTreeNode == null)
{
    <div style="float:right">
        <button type="button" class="btn btn-outline-primary" onclick="location.href='@Url.Action("Edit", "Sites", new { id = Model.Site.Id })'">Edit</button>
    </div>
}
@*@if (Model.RequestedVersionTreeNode == null || Model.RequestedVersionTreeNode is EditVersionIdentifier)
    {
        <div style="float:right">
            <button type="button" class="btn btn-outline-primary" onclick="location.href='@Url.Action("Edit", "Sites", new { id = Model.Site.Id, editVersion = Model.RequestedVersionTreeNode == null ? null : ((EditVersionIdentifier)Model.RequestedVersionTreeNode).IdAndVersionNumber })'">Edit</button>
        </div>
    }*@
<h4>@ViewData["Path"]</h4>
<h1>@Html.DisplayFor(model => model.Site.Name)</h1>
@*<span class="badge badge-secondary">@Model.Type</span>
    <span class="badge badge-secondary">@Model.Conditions</span>
    <span class="badge badge-secondary">@Model.Height</span>
    <span class="badge badge-secondary">@Model.Rating</span>*@

@if (!String.IsNullOrEmpty(Model.Site.Closed))
{
    <div class="alert alert-dark site-closed-text" role="alert">
        <span class="float-left badge badge-danger site-closed-badge">Closed</span>
        @Html.FromMarkdown(Model.Site.Closed)
        @*@Html.DisplayFor(Model => Model.Site.Closed)*@
    </div>
}

<div>
    <div class="row">
        <div class="col-md-4 order-md-last">
            @if (!String.IsNullOrEmpty(Model.Site.SmallPicture))
            {
                if (String.IsNullOrEmpty(Model.Site.SmallPictureHref))
                {
                    <text>
                        <img src="~/site_images/@Model.Site.SmallPicture" class="card-img-top" alt="Site photo" title="@Model.Site.SmallPictureTitle">
                    </text>
                }
                else
                {
                    <text>
                        <a href="@Model.Site.SmallPictureHref">
                            <img src="~/site_images/@Model.Site.SmallPicture" class="card-img-top" alt="Site photo" title="@Model.Site.SmallPictureTitle">
                        </a>
                    </text>
                }
            }
            @*<div class="card" style="width: 350px">
            <div class="card-body">
            <div class="card-text">*@
            <table>
                <tr>
                    <td>Type</td>
                    <td>@Model.Site.Type</td>
                </tr>
                <tr>
                    <td>Conditions</td>
                    <td>@Model.Site.Conditions</td>
                </tr>
                <tr>
                    <td>Height</td>
                    <td>@Model.Site.Height</td>
                </tr>
                <tr>
                    <td>Rating</td>
                    <td>@Model.Site.Rating</td>
                </tr>
            </table>
            @*</div>
            </div>
            </div>*@
            <div class="site_location_map">
                <a href="@GMapsHelper.GetSiteMapHref(Model)">
                    <img alt="Overview map" title="Overview map"
                         class="inset_map @(Model.Site.InsetMapPosition.Name.ToLowerInvariant().Replace(' ','_'))"
                         src="@Html.Raw(GMapsHelper.GetInsetStaticMapUrl(Model, 120, 120))" />
                    <img alt="Site map" title="Site map - click for interactive map"
                         src="@Html.Raw(GMapsHelper.GetMainStaticMapUrl(Model, 345, 250))" />
                </a>
            </div>
            <ul class="launch_list">
                @foreach (var launch in Model.Launches)
                {
                    <li class="row">
                        <span class="col-6 launch@((launch.IsClosed || Model.Site.IsClosed)? " closed" : "")"
                              title="@launch.Lat.ToString(@" \N0.00000;\S0.00000"),&nbsp;@launch.Lon.ToString(@"\E0.00000;\W0.00000")">
                            @(string.IsNullOrWhiteSpace(launch.Name) ? "Launch" : launch.Name)@(launch.IsClosed ? " [closed]" : "")
                        </span>
                        <a class="col-3"
                           title="Navigate to @(string.IsNullOrWhiteSpace(launch.Name) ? " launch" : launch.Name)@(launch.IsClosed ? " [closed]" : "" )"
                           href="https://www.google.com/maps/dir//'@launch.Lat.ToString(@" \N0.00000;\S0.00000"),@launch.Lon.ToString(@"\E0.00000;\W0.00000" )'">
                            <span class="badge badge-pill badge-primary">Navigate</span>
                        </a>
                        <a class="col-3"
                           title="Show on interactive map"
                           href="/Map?type=open@((launch.IsClosed || Model.Site.IsClosed) ?" ,closed":"")&amp;pin=@Model.Site.Name@(string.IsNullOrWhiteSpace(launch.Name ) ? "" : $" - {launch.Name}")">
                            <span class="badge badge-pill badge-primary">Map</span>
                        </a>
                    </li>
                }
            </ul>
            @Html.DisplayFor(model => model.Site.ShortLocation)
            @Html.FromMarkdown(Model.Site.ExtendedLocation)

            @if (Model.Launches.Any(l => l.EstaEmergencyMarker != null) || Model.MapShapes.Any(s => s.EstaEmergencyMarker != null))
            {
                <h3>000 Emergency Markers (<a href="https://www.triplezero.vic.gov.au/our-services#emergency-markers" title="Emergency markers pinpoint your exact location during an emergency in public open spaces or a hard to define locality. Click to learn more.">?</a>)</h3>
                <ul>
                    @foreach (var launch in Model.Launches.Where(l => l.EstaEmergencyMarker != null))
                    {
                        <li>
                            @launch.EstaEmergencyMarker: @(launch.Name ?? "Launch")
                        </li>
                    }
                    @foreach (var shape in Model.MapShapes.Where(s => s.EstaEmergencyMarker != null))
                    {
                        <li>
                            @shape.EstaEmergencyMarker: @shape.Category.Name@(string.IsNullOrWhiteSpace(shape.Name) ? "" : " - " + shape.Name)
                        </li>
                    }
                </ul>
            }

            @if (!string.IsNullOrEmpty(Model.Site.Landowners))
            {
                <h3>Landowners</h3>
                @Html.FromMarkdown(Model.Site.Landowners)
            }
            else
            {
                <h3>Landowners - ?</h3>
            }

            @if (Model.Contacts.All(c => c.IsContact == c.IsResponsible))
            {
                @await Component.InvokeAsync("Contacts", new SiteGuide.Web.ViewComponents.ContactsViewComponentModel() { Contacts = Model.Contacts, Title = "Contact/Responsible" })
            }
            else
            {
                @await Component.InvokeAsync("Contacts", new SiteGuide.Web.ViewComponents.ContactsViewComponentModel() { Contacts = Model.Contacts.Where(c => c.IsContact), Title = "Contact" })
                @await Component.InvokeAsync("Contacts", new SiteGuide.Web.ViewComponents.ContactsViewComponentModel() { Contacts = Model.Contacts.Where(c => c.IsResponsible), Title = "Responsible" })
            }

            @if (Model.SeeAlsos.Any())
            {
                <h3>See also</h3>
                @foreach (var seeAlso in Model.SeeAlsos)
                {
                    <div>
                        <a href="@seeAlso.Link">
                            @seeAlso.Name
                        </a>
                    </div>
                }
            }
        </div>
        <div class="col-md">
            @if (!string.IsNullOrEmpty(@Model.Site.Description))
            {
                <h3 class="d-md-none">Description</h3>
                @Html.FromMarkdown(Model.Site.Description)
            }

            @if (!string.IsNullOrEmpty(@Model.Site.Restrictions))
            {
                <div class="alert alert-warning" role="alert">
                    @Html.FromMarkdown(@Model.Site.Restrictions)
                </div>
            }

            @foreach (var video in Model.Videos)
            {
                <iframe class="embedded-video" width=445 height=250 frameborder="0" src="@video.Type.EmbedUrl.Replace("%id", video.Identifier.ToString())" webkitallowfullscreen mozallowfullscreen allowfullscreen>
                    &#160;@*&nbsp; - Hack to avoid collapsing element*@
                </iframe>
            }
            @if (Model.Site.Takeoff != null || Model.Launches.Any(l => !(string.IsNullOrEmpty(l.Conditions) && string.IsNullOrEmpty(l.Description) && string.IsNullOrEmpty(l.Closed))))
            {
                <h3>Takeoff</h3>
                @Html.FromMarkdown(Model.Site.Takeoff)
                @foreach (var launch in Model.Launches.Where(l => !(string.IsNullOrEmpty(l.Conditions) && string.IsNullOrEmpty(l.Description) && string.IsNullOrEmpty(l.Closed))))
                {
                    <h4>
                        @launch.Name
                    </h4>
                    @if (!string.IsNullOrEmpty(launch.Closed))
                    {
                        <div class="alert alert-dark site-closed-text" role="alert">
                            <span class="float-left badge badge-danger site-closed-badge">Closed</span>
                            @Html.FromMarkdown(launch.Closed)
                        </div>
                    }
                    @if (!String.IsNullOrEmpty(launch.Conditions))
                    {
                        <span>(@launch.Conditions)</span>
                    }
                    @Html.FromMarkdown(launch.Description)
                }
            }
            @if (Model.Site.Landing != null)
            {
                <h3>Landing</h3>
                @Html.FromMarkdown(Model.Site.Landing)
            }
            @if (Model.Site.FlightComments != null)
            {
                <h3>Flight</h3>
                @Html.FromMarkdown(Model.Site.FlightComments)
            }
            @if (Model.Site.HazardsComments != null)
            {
                <h3>Hazards / Comments</h3>
                @Html.FromMarkdown(Model.Site.HazardsComments)
            }
            @await Component.InvokeAsync("MapInformation", Model)
            @*<div class="row">
            <div class="col-md-2">
            @Html.DisplayNameFor(model => model.LastReviewDate)
            </div>
            <div class="col-md-10">
            @Html.DisplayFor(model => model.LastReviewDate)
            </div>
            </div>*@
        </div>
    </div>
</div>
@*<div>
        <a asp-action="Edit" asp-route-id="@Model.Id">Edit</a> |
        <a asp-action="Index">Back to List</a>
    </div>*@
